# !!!!!              Important              !!!!! #
#                                                 #
# Transfer the app archive to user's home         #
# directory before starting this configuration    #
#                                                 #
# !!!!!              Important              !!!!! #


# Updating system
sudo apt update

# Installing main applications
sudo snap install mosquitto unzip

# Forcing user's home directory
cd

# Making required folders
mkdir -p printserver/pyenv
cd printserver/

# Installing virtual environment module
sudo apt install python3-venv

# Creating and activating a new virtual environment
python3 -m venv pyenv
. pyenv/bin/activate

# Installing required python libraries
#pip3 install Flask paho-mqtt python-escpos gunicorn
pip3 install Flask==1.1.2
pip3 install gunicorn==20.1.0
pip3 install python-escpos==2.2.0
pip3 install paho-mqtt==1.5.1

# Setting up printserverservices as a System Service
sudo cp ~/printserver/deployment/printserverservices.service /etc/systemd/system/
sudo systemctl daemon-reload
sudo systemctl enable printserverservices
sudo systemctl start printserverservices
# Use following command to check the service
# Type in "q" to quit when necessary
#sudo systemctl status printserverservices

# Setting up printserverapi as a System Service
sudo cp ~/printserver/deployment/printserverapi.service /etc/systemd/system/
sudo systemctl daemon-reload
sudo systemctl enable printserverapi
sudo systemctl start printserverapi
# Use following command to check the service
# Type in "q" to quit when necessary
#sudo systemctl status printserverapi

# Change system timezone to Africa/Casablanca
sudo timedatectl set-timezone Africa/Casablanca

# Network settup if not set during setup
cd ~/printserver/
# Edit the file to match the required network configuration
nano deployment/00-installer-config.yaml
# Then excute the following commands
mkdir deployment/netplan
sudo cp /etc/netplan/* ~/printserver/deployment/netplan/
sudo rm /etc/netplan/*.yaml
sudo cp 00-installer-config.yaml /etc/netplan/
sudo netplan apply
